summaryrefslogtreecommitdiffstats
path: root/meta/recipes-support/gnutls
diff options
context:
space:
mode:
authorRichard Purdie <richard.purdie@linuxfoundation.org>2025-11-07 13:31:53 +0000
committerRichard Purdie <richard.purdie@linuxfoundation.org>2025-11-07 13:31:53 +0000
commit8c22ff0d8b70d9b12f0487ef696a7e915b9e3173 (patch)
treeefdc32587159d0050a69009bdf2330a531727d95 /meta/recipes-support/gnutls
parentd412d2747595c1cc4a5e3ca975e3adc31b2f7891 (diff)
downloadpoky-8c22ff0d8b70d9b12f0487ef696a7e915b9e3173.tar.gz
The poky repository master branch is no longer being updated.
You can either: a) switch to individual clones of bitbake, openembedded-core, meta-yocto and yocto-docs b) use the new bitbake-setup You can find information about either approach in our documentation: https://docs.yoctoproject.org/ Note that "poky" the distro setting is still available in meta-yocto as before and we continue to use and maintain that. Long live Poky! Some further information on the background of this change can be found in: https://lists.openembedded.org/g/openembedded-architecture/message/2179 Signed-off-by: Richard Purdie <richard.purdie@linuxfoundation.org>
Diffstat (limited to 'meta/recipes-support/gnutls')
-rw-r--r--meta/recipes-support/gnutls/gnutls/0001-Creating-.hmac-file-should-be-excuted-in-target-envi.patch26
-rw-r--r--meta/recipes-support/gnutls/gnutls/Add-ptest-support.patch57
-rw-r--r--meta/recipes-support/gnutls/gnutls/arm_eabi.patch29
-rw-r--r--meta/recipes-support/gnutls/gnutls/run-ptest101
-rw-r--r--meta/recipes-support/gnutls/gnutls_3.8.10.bb103
-rw-r--r--meta/recipes-support/gnutls/libtasn1/dont-depend-on-help2man.patch26
-rw-r--r--meta/recipes-support/gnutls/libtasn1_4.20.0.bb22
7 files changed, 0 insertions, 364 deletions
diff --git a/meta/recipes-support/gnutls/gnutls/0001-Creating-.hmac-file-should-be-excuted-in-target-envi.patch b/meta/recipes-support/gnutls/gnutls/0001-Creating-.hmac-file-should-be-excuted-in-target-envi.patch
deleted file mode 100644
index 2dccea7859..0000000000
--- a/meta/recipes-support/gnutls/gnutls/0001-Creating-.hmac-file-should-be-excuted-in-target-envi.patch
+++ /dev/null
@@ -1,26 +0,0 @@
1From c4f6cb380471b5e5478ae6f7f8c5604a6a64ec1c Mon Sep 17 00:00:00 2001
2From: Lei Maohui <leimaohui@fujitsu.com>
3Date: Mon, 23 May 2022 10:44:43 +0900
4Subject: [PATCH] Creating .hmac file should be excuted in target environment,
5 so deleted it from build process.
6
7Upstream-Status: Inappropriate [https://gitlab.com/gnutls/gnutls/-/issues/1373]
8Signed-off-by: Lei Maohui <leimaohui@fujitsu.com>
9---
10 lib/Makefile.am | 3 +--
11 1 file changed, 1 insertion(+), 2 deletions(-)
12
13diff --git a/lib/Makefile.am b/lib/Makefile.am
14index a50d311..193ea19 100644
15--- a/lib/Makefile.am
16+++ b/lib/Makefile.am
17@@ -272,8 +272,7 @@ hmac_file = .libs/.$(gnutls_so).hmac
18
19 all-local: $(hmac_file)
20
21-$(hmac_file): libgnutls.la fipshmac
22- $(AM_V_GEN) $(builddir)/fipshmac > $@-t && mv $@-t $@
23+.libs/.$(gnutls_so).hmac:
24
25 CLEANFILES = $(hmac_file)
26 endif
diff --git a/meta/recipes-support/gnutls/gnutls/Add-ptest-support.patch b/meta/recipes-support/gnutls/gnutls/Add-ptest-support.patch
deleted file mode 100644
index 339d3d2f9e..0000000000
--- a/meta/recipes-support/gnutls/gnutls/Add-ptest-support.patch
+++ /dev/null
@@ -1,57 +0,0 @@
1From 6abc86acecff5a30173eb78a971ec5b65f77e1de Mon Sep 17 00:00:00 2001
2From: Ravineet Singh <ravineet.a.singh@est.tech>
3Date: Tue, 10 Jan 2023 16:11:10 +0100
4Subject: [PATCH] gnutls: add ptest support
5
6Upstream-Status: Inappropriate [embedded specific]
7Signed-off-by: Ravineet Singh <ravineet.a.singh@est.tech>
8---
9 Makefile.am | 3 +++
10 configure.ac | 2 ++
11 tests/Makefile.am | 6 ++++++
12 3 files changed, 11 insertions(+)
13
14diff --git a/Makefile.am b/Makefile.am
15index 843193f..816b09f 100644
16--- a/Makefile.am
17+++ b/Makefile.am
18@@ -194,6 +194,9 @@ dist-hook:
19 distcheck-hook:
20 @test -d "$(top_srcdir)/po/.reference" || { echo "PO files are not downloaded; run ./bootstrap without --skip-po"; exit 1; }
21
22+install-ptest:
23+ $(MAKE) -C tests DESTDIR=$(DESTDIR)/tests $@
24+
25 .PHONY: abi-check abi-dump-versioned abi-dump-latest pic-check symbol-check local-code-coverage-output files-update AUTHORS
26
27 include $(top_srcdir)/cligen/cligen.mk
28diff --git a/configure.ac b/configure.ac
29index 1744813..efb9e34 100644
30--- a/configure.ac
31+++ b/configure.ac
32@@ -1491,6 +1491,8 @@ AC_SUBST(LIBGNUTLS_CFLAGS)
33
34 AM_CONDITIONAL(NEEDS_LIBRT, test "$gnutls_needs_librt" = "yes")
35
36+AM_EXTRA_RECURSIVE_TARGETS([buildtest-TESTS])
37+
38 AC_DEFINE([GNUTLS_INTERNAL_BUILD], 1, [We allow temporarily usage of deprecated functions - until they are removed.])
39
40 hw_features=
41diff --git a/tests/Makefile.am b/tests/Makefile.am
42index 189d068..8430b05 100644
43--- a/tests/Makefile.am
44+++ b/tests/Makefile.am
45@@ -678,6 +678,12 @@ SH_LOG_COMPILER = $(SHELL)
46 AM_VALGRINDFLAGS = --suppressions=$(srcdir)/suppressions.valgrind
47 LOG_COMPILER = $(LOG_VALGRIND)
48
49+install-ptest: $(check_PROGRAMS)
50+ @$(INSTALL) -d $(DESTDIR)
51+ @for file in $^; do \
52+ $(INSTALL_PROGRAM) $$file $(DESTDIR) ; \
53+ done
54+
55 distclean-local:
56 rm -rf softhsm-*.db softhsm-*.config *.tmp tmp-* x509-crt-list-import-url.config.db port.lock.d
57
diff --git a/meta/recipes-support/gnutls/gnutls/arm_eabi.patch b/meta/recipes-support/gnutls/gnutls/arm_eabi.patch
deleted file mode 100644
index d493448aab..0000000000
--- a/meta/recipes-support/gnutls/gnutls/arm_eabi.patch
+++ /dev/null
@@ -1,29 +0,0 @@
1From 46b3079095c5ceb0dc742785853bbaf288f325c6 Mon Sep 17 00:00:00 2001
2From: Joe Slater <jslater@windriver.com>
3Date: Wed, 25 Jan 2017 13:52:59 -0800
4Subject: [PATCH] gnutls: account for ARM_EABI
5
6Certain syscall's are not availabe for arm-eabi, so we eliminate
7reference to them.
8
9Upstream-Status: Pending
10
11Signed-off-by: Joe Slater <jslater@windriver.com>
12---
13 tests/seccomp.c | 2 ++
14 1 file changed, 2 insertions(+)
15
16diff --git a/tests/seccomp.c b/tests/seccomp.c
17index 881f0bb..5f9204a 100644
18--- a/tests/seccomp.c
19+++ b/tests/seccomp.c
20@@ -55,7 +55,9 @@ int disable_system_calls(void)
21
22 ADD_SYSCALL(nanosleep, 0);
23 ADD_SYSCALL(clock_nanosleep, 0);
24+#if ! defined(__ARM_EABI__)
25 ADD_SYSCALL(time, 0);
26+#endif
27 ADD_SYSCALL(getpid, 0);
28 ADD_SYSCALL(gettimeofday, 0);
29 #if defined(HAVE_CLOCK_GETTIME)
diff --git a/meta/recipes-support/gnutls/gnutls/run-ptest b/meta/recipes-support/gnutls/gnutls/run-ptest
deleted file mode 100644
index b7827e1358..0000000000
--- a/meta/recipes-support/gnutls/gnutls/run-ptest
+++ /dev/null
@@ -1,101 +0,0 @@
1#!/bin/sh
2
3rjob() {
4 local job=$1
5 local log=$2
6
7 # TODO: Output will be garbled
8 ./${job} >> ${log} 2>&1
9
10 ret=$?
11 case $ret in
12 0)
13 echo "PASS: $t" >> ${log}
14 echo "PASS: $t"
15 ;;
16 77)
17 echo "SKIP: $t" >> ${log}
18 echo "SKIP: $t"
19 ;;
20 *)
21 echo "FAIL: $t" >> ${log}
22 echo "FAIL: $t"
23 ;;
24 esac
25}
26
27is_disallowed() {
28 local key=$1
29 $(echo ${test_disallowlist} | grep -w -q ${key})
30 return $?
31}
32
33# TODO
34# This list should probably be in a external file
35# Testcases defined here either take very long time (dtls-stress)
36# or are dependent on local files (certs, etc) in local file system
37# currently not exported to target.
38
39test_disallowlist=""
40test_disallowlist="${test_disallowlist} compress-cert-conf"
41test_disallowlist="${test_disallowlist} dtls-stress"
42test_disallowlist="${test_disallowlist} handshake-large-cert"
43test_disallowlist="${test_disallowlist} id-on-xmppAddr"
44test_disallowlist="${test_disallowlist} mini-x509-cas"
45test_disallowlist="${test_disallowlist} pkcs12_simple"
46test_disallowlist="${test_disallowlist} protocol-set-allowlist"
47test_disallowlist="${test_disallowlist} psk-file"
48test_disallowlist="${test_disallowlist} rawpk-api"
49test_disallowlist="${test_disallowlist} set_pkcs12_cred"
50test_disallowlist="${test_disallowlist} system-override-curves-allowlist"
51test_disallowlist="${test_disallowlist} system-override-hash"
52test_disallowlist="${test_disallowlist} system-override-sig"
53test_disallowlist="${test_disallowlist} system-override-sig-tls"
54test_disallowlist="${test_disallowlist} system-prio-file"
55test_disallowlist="${test_disallowlist} x509cert-tl"
56
57LOG=${PWD}/tests.log
58cd tests
59max_njobs=$(grep -c ^processor /proc/cpuinfo)
60njobs=0
61
62set +e
63
64for t in *; do
65 [ -x $t ] || continue
66 [ -f $t ] || continue
67
68 is_disallowed ${t}
69 [ $? -eq 0 ] && continue
70
71 rjob ${t} ${LOG} &
72 one=1
73 njobs=$(expr ${njobs} + ${one})
74 if [ ${njobs} -eq ${max_njobs} ]; then
75 wait
76 njobs=0
77 fi
78done
79wait
80
81skipped=$(grep -c SKIP ${LOG})
82passed=$(grep -c PASS ${LOG})
83failed=$(grep -c FAIL ${LOG})
84total=$(expr ${passed} + ${failed} + ${skipped})
85
86if [ ${failed} -ne 0 ]; then
87 echo
88 echo "Tests failed for gnutls, log is:"
89 echo "--------------------"
90 cat ${LOG}
91 echo
92fi
93
94echo
95echo "gnutls test summary:"
96echo "--------------------"
97echo "total: ${total}"
98echo "pass : ${passed}"
99echo "fail : ${failed}"
100echo "skip : ${skipped}"
101echo
diff --git a/meta/recipes-support/gnutls/gnutls_3.8.10.bb b/meta/recipes-support/gnutls/gnutls_3.8.10.bb
deleted file mode 100644
index 2ef71a1213..0000000000
--- a/meta/recipes-support/gnutls/gnutls_3.8.10.bb
+++ /dev/null
@@ -1,103 +0,0 @@
1SUMMARY = "GNU Transport Layer Security Library"
2DESCRIPTION = "a secure communications library implementing the SSL, \
3TLS and DTLS protocols and technologies around them."
4HOMEPAGE = "https://gnutls.org/"
5BUGTRACKER = "https://savannah.gnu.org/support/?group=gnutls"
6
7LICENSE = "GPL-3.0-or-later & LGPL-2.1-or-later"
8LICENSE:${PN} = "LGPL-2.1-or-later"
9LICENSE:${PN}-xx = "LGPL-2.1-or-later"
10LICENSE:${PN}-bin = "GPL-3.0-or-later"
11LICENSE:${PN}-openssl = "GPL-3.0-or-later"
12
13LIC_FILES_CHKSUM = "file://README.md;beginline=181;endline=205;md5=e159ff2a6e9cc95141fb0eaff733bba3 \
14 file://COPYING;md5=1ebbd3e34237af26da5dc08a4e440464 \
15 file://COPYING.LESSERv2;md5=4bf661c1e3793e55c8d1051bc5e0ae21"
16
17DEPENDS = "nettle gmp virtual/libiconv libunistring"
18
19SHRT_VER = "${@d.getVar('PV').split('.')[0]}.${@d.getVar('PV').split('.')[1]}"
20
21SRC_URI = "https://www.gnupg.org/ftp/gcrypt/gnutls/v${SHRT_VER}/gnutls-${PV}.tar.xz \
22 file://arm_eabi.patch \
23 file://0001-Creating-.hmac-file-should-be-excuted-in-target-envi.patch \
24 file://run-ptest \
25 file://Add-ptest-support.patch \
26 "
27
28SRC_URI[sha256sum] = "db7fab7cce791e7727ebbef2334301c821d79a550ec55c9ef096b610b03eb6b7"
29
30inherit autotools texinfo pkgconfig gettext lib_package gtk-doc ptest
31
32PACKAGECONFIG ??= "libidn libtasn1 ${@bb.utils.filter('DISTRO_FEATURES', 'seccomp', d)}"
33
34# You must also have CONFIG_SECCOMP enabled in the kernel for
35# seccomp to work.
36PACKAGECONFIG[seccomp] = "--with-libseccomp-prefix=${STAGING_EXECPREFIXDIR},ac_cv_libseccomp=no,libseccomp"
37PACKAGECONFIG[libidn] = "--with-idn,--without-idn,libidn2"
38PACKAGECONFIG[libtasn1] = "--without-included-libtasn1,--with-included-libtasn1,libtasn1"
39PACKAGECONFIG[p11-kit] = "--with-p11-kit,--without-p11-kit,p11-kit"
40PACKAGECONFIG[tpm] = "--with-tpm,--without-tpm,trousers"
41PACKAGECONFIG[fips] = "--enable-fips140-mode --with-libdl-prefix=${STAGING_BASELIBDIR}"
42PACKAGECONFIG[dane] = "--enable-libdane,--disable-libdane,unbound"
43# Certificate compression
44PACKAGECONFIG[brotli] = "--with-brotli,--without-brotli,brotli"
45PACKAGECONFIG[zlib] = "--with-zlib,--without-zlib,zlib"
46PACKAGECONFIG[zstd] = "--with-zstd,--without-zstd,zstd"
47
48EXTRA_OECONF = " \
49 --enable-doc \
50 --disable-rpath \
51 --enable-openssl-compatibility \
52 --with-libpthread-prefix=${STAGING_DIR_HOST}${prefix} \
53 --with-librt-prefix=${STAGING_DIR_HOST}${prefix} \
54 --with-default-trust-store-file=${sysconfdir}/ssl/certs/ca-certificates.crt \
55"
56
57# Otherwise the tools try and use HOSTTOOLS_DIR/bash as a shell.
58export POSIX_SHELL = "${base_bindir}/sh"
59
60do_configure:prepend() {
61 for dir in . lib; do
62 rm -f ${dir}/aclocal.m4 ${dir}/m4/libtool.m4 ${dir}/m4/lt*.m4
63 done
64}
65
66do_compile_ptest() {
67 oe_runmake -C tests buildtest-TESTS
68}
69
70do_install:append:class-target() {
71 if ${@bb.utils.contains('PACKAGECONFIG', 'fips', 'true', 'false', d)}; then
72 install -d ${D}${bindir}/bin
73 install -m 0755 ${B}/lib/.libs/fipshmac ${D}/${bindir}/
74 fi
75}
76
77PACKAGES =+ "${PN}-dane ${PN}-openssl ${PN}-xx ${PN}-fips"
78
79FILES:${PN}-dev += "${bindir}/gnutls-cli-debug"
80
81FILES:${PN}-dane = "${libdir}/libgnutls-dane.so.*"
82FILES:${PN}-openssl = "${libdir}/libgnutls-openssl.so.*"
83FILES:${PN}-xx = "${libdir}/libgnutlsxx.so.*"
84FILES:${PN}-fips = "${bindir}/fipshmac"
85
86RDEPENDS:${PN}-ptest += "python3"
87
88BBCLASSEXTEND = "native nativesdk"
89
90pkg_postinst_ontarget:${PN}-fips () {
91 if test -x ${bindir}/fipshmac
92 then
93 mkdir ${sysconfdir}/gnutls
94 touch ${sysconfdir}/gnutls/config
95 ${bindir}/fipshmac ${libdir}/libgnutls.so.30.*.* > ${libdir}/.libgnutls.so.30.hmac
96 ${bindir}/fipshmac ${libdir}/libnettle.so.8.* > ${libdir}/.libnettle.so.8.hmac
97 ${bindir}/fipshmac ${libdir}/libgmp.so.10.*.* > ${libdir}/.libgmp.so.10.hmac
98 ${bindir}/fipshmac ${libdir}/libhogweed.so.6.* > ${libdir}/.libhogweed.so.6.hmac
99 fi
100}
101
102CVE_STATUS[CVE-2025-32989] = "fixed-version: fixed in version 3.8.10"
103CVE_STATUS[CVE-2025-32990] = "fixed-version: fixed in version 3.8.10"
diff --git a/meta/recipes-support/gnutls/libtasn1/dont-depend-on-help2man.patch b/meta/recipes-support/gnutls/libtasn1/dont-depend-on-help2man.patch
deleted file mode 100644
index 216d636793..0000000000
--- a/meta/recipes-support/gnutls/libtasn1/dont-depend-on-help2man.patch
+++ /dev/null
@@ -1,26 +0,0 @@
1From 629fc6427710e48b78f8b1f300dd698fe898cfd4 Mon Sep 17 00:00:00 2001
2From: Marko Lindqvist <cazfi74@gmail.com>
3Date: Mon, 7 Jan 2013 01:49:40 +0200
4Subject: [PATCH] libtasn1: remove help2man dependency
5
6Upstream-Status: Inappropriate
7
8Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
9
10---
11 doc/Makefile.am | 2 +-
12 1 file changed, 1 insertion(+), 1 deletion(-)
13
14diff --git a/doc/Makefile.am b/doc/Makefile.am
15index a0171a5..8aa4d3d 100644
16--- a/doc/Makefile.am
17+++ b/doc/Makefile.am
18@@ -28,7 +28,7 @@ libtasn1_TEXINFOS += asn1Coding-help.texi asn1Decoding-help.texi asn1Parser-help
19
20 AM_MAKEINFOHTMLFLAGS = --no-split $(AM_MAKEINFOFLAGS)
21
22-dist_man_MANS = $(gdoc_MANS) asn1Parser.1 asn1Coding.1 asn1Decoding.1
23+dist_man_MANS = $(gdoc_MANS)
24
25 HELP2MAN_OPTS = --info-page libtasn1
26
diff --git a/meta/recipes-support/gnutls/libtasn1_4.20.0.bb b/meta/recipes-support/gnutls/libtasn1_4.20.0.bb
deleted file mode 100644
index 8127ba5b1d..0000000000
--- a/meta/recipes-support/gnutls/libtasn1_4.20.0.bb
+++ /dev/null
@@ -1,22 +0,0 @@
1SUMMARY = "Library for ASN.1 and DER manipulation"
2DESCRIPTION = "A highly portable C library that encodes and decodes \
3DER/BER data following an ASN.1 schema. "
4HOMEPAGE = "http://www.gnu.org/software/libtasn1/"
5
6LICENSE = "GPL-3.0-or-later & LGPL-2.1-or-later"
7LICENSE:${PN}-bin = "GPL-3.0-or-later"
8LICENSE:${PN} = "LGPL-2.1-or-later"
9LIC_FILES_CHKSUM = "file://COPYING;md5=1ebbd3e34237af26da5dc08a4e440464 \
10 file://COPYING.LESSERv2;md5=4bf661c1e3793e55c8d1051bc5e0ae21"
11
12SRC_URI = "${GNU_MIRROR}/libtasn1/libtasn1-${PV}.tar.gz \
13 file://dont-depend-on-help2man.patch \
14 "
15
16DEPENDS = "bison-native"
17
18SRC_URI[sha256sum] = "92e0e3bd4c02d4aeee76036b2ddd83f0c732ba4cda5cb71d583272b23587a76c"
19
20inherit autotools texinfo lib_package gtk-doc
21
22BBCLASSEXTEND = "native nativesdk"